#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Patrick Gu <Patrick.Gu@Sun.COM>
#
#  Copyright 2005 Sun Microsystems, Inc.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.


from ldtp import *
from ldtputils import *

def mark_read():
        try:
                if imaporlocal == '2':
                        imap = 2
                else:
                        imap =1
                selectrowindex ('frmEvolution-Mail', 'ttblMailFolderTree', 8)
                #print getrowcount('frmEvolution-Mail','ttblMailFolderTree') 
                #selectrow ('frmEvolution-Mail','ttblMailFolderTree','Inbox', imap)
                count = getrowcount ('frmEvolution-Mail', 'ttblMessageList')
                if count <= 1:
                        log ('There are too few  message in this folder', 'fail')
                        raise LdtpExecutionError (0)

                selectrowindex('frmEvolution-Mail', 'ttblMessageList', 0)
                read_status = getcellvalue('frmEvolution-Mail', 'ttblMessageList',0,0)
                if read_status == '1':
                        selectmenuitem('frmEvolution-Mail','mnuUnread')
			return '0'

                else:  
                	selectmenuitem('frmEvolution-Mail','mnuRead')
			return '1'

        except ldtp.error, msg:
                log ('Properties of read' + ' failed '+ str (msg), 'cause')
                #log ('Search based on ' + search_type + ' failed', 'fail')
                raise LdtpExecutionError (0)

def goOffline():
        try:
                #remap ('evolution-2.4', 'frmEvolution-Mail')

                if stateenabled('frmEvolution-Mail', 'btnSend/Receive') == 1:
                        selectmenuitem('frmEvolution-Mail', 'mnuFile;mnuWorkOffline')

                #if doesmenuitemexist('frmEvolution-Mail', 'mnuFile;mnuWorkOnline') != 1:
                #       log ('Go offline failed')
                #undoremap ('evolution-2.4', 'frmEvolution-Mail')

        except ldtp.error, msg:
                log ('Go offline failed ' + str (msg), 'cause')
                log ('Go offline failed ', 'Fail' );
                raise LdtpExecutionError (0)

def goOnline():
        try:
                if stateenabled('frmEvolution-Mail', 'btnSend/Receive') == 0:
                        selectmenuitem('frmEvolution-Mail', 'mnuFile;mnuWorkOnline')

        except ldtp.error, msg:
                log ('Go online failed ' + str (msg), 'cause')
                log ('Go online failed ', 'Fail' );
                raise LdtpExecutionError (0)



#Main start here
data_object = LdtpDataFileParser (datafilename)
folder = data_object.gettagvalue ('folder')[0]
imaporlocal = data_object.gettagvalue ('imaporlocal')[0]
goOffline()
time.sleep(4)
flag = mark_read()
goOnline()
time.sleep(4)
if waittillguinotexist ('frmEvolution-Mail') == 0:
        log ('Failed during clicking the send button', 'error')
        raise LdtpExecutionError (0)
else:
        read_status = getcellvalue('frmEvolution-Mail', 'ttblMessageList',0,0)
        if read_status == flag:
        	log ('Mark to Read passed', 'pass')
        else:
                log ('Mark to Read failed', 'fail')
                raise LdtpExecutionError (0)

