#
#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Patrick Gu <Patrick.Gu@Sun.COM>
#
#  Copyright 2005 Sun Microsystems, Inc.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.


import time

from ldtp import *
from evoutils.mail import *

# Section to compose a new mail through File menu
def compose_mail (to, subject, body, cc=''):
    try:
        #selectmenuitem ('frmEvolution-Mail', 'mnuView;mnuWindow;mnuMail')
        time.sleep (3)
        #selectmenuitem ('frmEvolution-Mail', 'mnuFile;mnuNew;mnuMailMessage')
	click ('frmEvolution-Mail', 'btnNew')
        if waittillguiexist ('frmComposeamessage') == 0:
            log('Compose message window does not appear', 'error')
            raise LdtpExecutionError (0)
        else:
            populate_mail_header (to, subject, body, cc)
            click ('frmComposeamessage', 'btnSend')
            #if waittillguinotexist ('frmComposeamessage') == 0:
            #    log ('Failed during clicking the send button', 'error')
            #    raise LdtpExecutionError (0)
            #else:
            #    releasecontext();
            #    click ('frmEvolution-Mail', 'btnSend/Receive')
            #    time.sleep (5)
            #    if verifymailwithimage ('Sent', '-1', 'IMAGES/composemail_refimg.png') == 1:
            #            log ('Compose new message', 'pass')
            #    else:
            #            log ('Compose new message', 'fail')

    except ldtp.error, msg:
        log ('Compose new message failed ' + str (msg), 'cause')
        log ('Compose new message failed', 'Fail' );
        raise LdtpExecutionError (0)

def goOffline():
	try:
                #remap ('evolution-2.4', 'frmEvolution-Mail')

		if stateenabled('frmEvolution-Mail', 'btnSend/Receive') == 1:
			selectmenuitem('frmEvolution-Mail', 'mnuFile;mnuWorkOffline')
	 	
		#if doesmenuitemexist('frmEvolution-Mail', 'mnuFile;mnuWorkOnline') != 1:
		#	log ('Go offline failed')	
                #undoremap ('evolution-2.4', 'frmEvolution-Mail')

	
 	except ldtp.error, msg:
        	log ('Go offline failed ' + str (msg), 'cause')
        	log ('Go offline failed ', 'Fail' );
        	raise LdtpExecutionError (0)

def goOnline():
        try:
                if stateenabled('frmEvolution-Mail', 'btnSend/Receive') == 0:
                        selectmenuitem('frmEvolution-Mail', 'mnuFile;mnuWorkOnline')

        except ldtp.error, msg:
                log ('Go online failed ' + str (msg), 'cause')
                log ('Go online failed ', 'Fail' );
                raise LdtpExecutionError (0)


#Reading Input from File
data_object = LdtpDataFileParser (datafilename)
to = data_object.gettagvalue ('to')[0]
cc = data_object.gettagvalue ('cc')
subject = data_object.gettagvalue ('subject')[0]
body = data_object.gettagvalue ('body')[0]

goOffline()
if cc:
        compose_mail (to, subject, body, cc[0])
else:
        compose_mail (to, subject, body)

goOnline()

if waittillguinotexist ('frmEvolution-Mail') == 0:
	log ('Failed during clicking the send button', 'error')
        raise LdtpExecutionError (0)
else:
        releasecontext();
        time.sleep(2)
        click ('frmEvolution-Mail', 'btnSend/Receive')
        time.sleep (5)
        if verifymailwithimage ('Sent', '-1', 'IMAGES/composemail_refimg.png') == 1:
        	log ('Compose new message', 'pass')
        else:
                log ('Compose new message', 'fail')

